"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Address = _interopRequireDefault(require("ilib-es6/lib/Address"));

var _AddressFmt = _interopRequireDefault(require("ilib-es6/lib/AddressFmt"));

var _hash = _interopRequireDefault(require("../utils/hash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Address =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Address, _React$Component);

  function Address(props) {
    var _this;

    _classCallCheck(this, Address);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Address).call(this, props));
    var locale = props.locale,
        style = props.style; // data for the current locale should already be loaded, so we can create
    // this formatter synchronously

    _this.state = {
      formatter: new _AddressFmt["default"]({
        locale: locale,
        style: style
      })
    };
    return _this;
  }

  _createClass(Address, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _this2 = this;

      if (prevProps.locale !== this.props.locale || prevProps.style !== this.props.style) {
        // the data for this may not be loaded yet, so we have to create the new
        // formatter asynchronously, just in case, and then set it into the state
        return _AddressFmt["default"].create({
          locale: this.props.locale,
          style: this.props.style
        }).then(function (fmt) {
          _this2.setState({
            formatter: fmt
          });
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          separator = _this$props.separator,
          locale = _this$props.locale,
          address = _this$props.address,
          id = _this$props.id,
          wrapper = _this$props.wrapper,
          className = _this$props.className;
      separator = separator || React.createElement("br", null);
      wrapper = wrapper || React.createElement("span", null);
      var add = typeof address === "string" ? new _Address["default"](this.props.address, {
        locale: locale
      }) : address;
      var ret = this.state.formatter.format(add).split(/\n/).filter(function (line) {
        return line && line.trim() !== "";
      });

      if (ret.length > 1) {
        var tmp = [],
            index = 0;
        ret.slice(0, ret.length - 1).forEach(function (line) {
          tmp.push(line);
          tmp.push(React.cloneElement(separator, {
            key: index++
          }));
        });
        tmp.push(ret[ret.length - 1]);
        ret = tmp;
      }

      id = id || (0, _hash["default"])(ret.join(" "));
      var attrs = {
        key: id,
        id: id
      };
      className && (attrs["className"] = className);
      return React.cloneElement(wrapper, attrs, ret);
    }
  }]);

  return Address;
}(React.Component);

_defineProperty(Address, "propTypes", {
  locale: _propTypes["default"].string,
  style: _propTypes["default"].string,
  id: _propTypes["default"].string,
  wrapper: _propTypes["default"]["object"],
  address: _propTypes["default"]["object"].isRequired,
  children: _propTypes["default"].any
});

var _default = Address;
exports["default"] = _default;
//# sourceMappingURL=Address.js.map
