"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _DateRngFmt = _interopRequireDefault(require("ilib-es6/lib/DateRngFmt"));

var _hash = _interopRequireDefault(require("../utils/hash"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DateRngFmt =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DateRngFmt, _React$Component);

  function DateRngFmt(props) {
    var _this;

    _classCallCheck(this, DateRngFmt);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DateRngFmt).call(this, props));
    _this.state = {
      formatter: new _DateRngFmt["default"](props)
    };
    return _this;
  }

  _createClass(DateRngFmt, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _this2 = this;

      if (!(0, _utils["default"])(prevProps, this.props, ["from", "start", "end", "wrapper", "className"])) {
        return _DateRngFmt["default"].create(props).then(function (fmt) {
          _this2.setState({
            formatter: fmt
          });
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _ref = this.props || {},
          className = _ref.className,
          start = _ref.start,
          end = _ref.end;

      var _ref2 = this.props || {},
          id = _ref2.id,
          wrapper = _ref2.wrapper;

      var ret = this.state.formatter.format(start, end);

      if (wrapper) {
        id = id || (0, _hash["default"])(ret);
        var attrs = {
          key: id,
          id: id
        };
        className && (attrs["className"] = className);
        return typeof wrapper === "string" ? React.createElement(wrapper, attrs, ret) : React.cloneElement(wrapper, attrs, ret);
      } else {
        return ret;
      }
    }
  }]);

  return DateRngFmt;
}(React.Component);

_defineProperty(DateRngFmt, "propTypes", {
  locale: _propTypes["default"].string,
  calendar: _propTypes["default"].string,
  timezone: _propTypes["default"].string,
  length: _propTypes["default"].string,
  clock: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  start: _propTypes["default"].any.isRequired,
  end: _propTypes["default"].any.isRequired,
  id: _propTypes["default"].string,
  wrapper: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"]["object"]])
});

var _default = DateRngFmt;
exports["default"] = _default;
//# sourceMappingURL=DateRngFmt.js.map
