"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withLocale = withLocale;
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _ilibEs = _interopRequireDefault(require("ilib-es6"));

var _ResBundle = _interopRequireDefault(require("ilib-es6/lib/ResBundle"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var locale = _ilibEs["default"].getLocale();

var rb = new _ResBundle["default"]({
  locale: locale
});
var LocaleContext = React.createContext({
  locale: locale,
  rb: rb
});

function withLocale(Component) {
  return function LocalizedComponent(props) {
    return React.createElement(LocaleContext.Consumer, null, function (value) {
      return React.createElement(Component, _extends({}, props, {
        locale: value.locale,
        rb: value.rb
      }));
    });
  };
}

;
var _default = LocaleContext;
exports["default"] = _default;
//# sourceMappingURL=LocaleContext.js.map
