"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _LocaleContext = _interopRequireDefault(require("./LocaleContext"));

var _ilibEs = _interopRequireDefault(require("ilib-es6"));

var _ResBundle = _interopRequireDefault(require("ilib-es6/lib/ResBundle"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var LocaleDataProvider =
/*#__PURE__*/
function (_React$Component) {
  _inherits(LocaleDataProvider, _React$Component);

  function LocaleDataProvider(props) {
    var _this;

    _classCallCheck(this, LocaleDataProvider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LocaleDataProvider).call(this, props));
    _this.state = {
      locale: _ilibEs["default"].getLocale(),
      rb: null,
      mainApp: null
    };
    return _this;
  }

  _createClass(LocaleDataProvider, [{
    key: "loadMainApp",
    value: function loadMainApp() {
      //  eslint-disable-next-line
      System["import"]("../App.jsx").then(function (module) {
        console.log("Main App loaded.");
        this.setState({
          mainApp: React.createElement(_LocaleContext["default"].Provider, {
            value: {
              locale: this.state.locale,
              rb: this.state.rb
            }
          }, React.createElement(module["default"], {}))
        });
      }.bind(this));
    }
  }, {
    key: "loadDataAndApp",
    value: function loadDataAndApp() {
      var locale = this.props.locale || _ilibEs["default"].getLocale();

      if (_ilibEs["default"].isDynData()) {
        // under dynamic data, we have to ensure the data is loaded first before
        // we load the main app
        var webpackLoader = _ilibEs["default"]._load;
        webpackLoader.ensureLocale(locale, "./locale", function (results) {
          if (results) {
            console.log("Locale data for locale ".concat(this.props.locale, " loaded."));
            this.loadMainApp(locale);
          } else {
            console.log("Locale data for locale ".concat(locale, " were NOT loaded"));
          }
        }.bind(this));
      } else {
        // data is already assembled and loaded, so just load the main app directly
        this.setState({
          locale: locale,
          rb: new _ResBundle["default"]({
            locale: this.props.locale,
            name: this.props.name,
            type: "html"
          })
        });
        this.loadMainApp(locale);
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.loadDataAndApp();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (prevProps.locale !== this.props.locale || prevProps.translationsDir !== this.props.translationsDir) {
        this.loadDataAndApp();
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.state.mainApp || React.createElement("div", null, "Loading...");
    }
  }]);

  return LocaleDataProvider;
}(React.Component);

_defineProperty(LocaleDataProvider, "propTypes", {
  locale: _propTypes["default"].string,
  translationsDir: _propTypes["default"].string
});

var _default = LocaleDataProvider;
exports["default"] = _default;
//# sourceMappingURL=LocaleDataProvider.js.map
