"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _PhoneNumber = _interopRequireDefault(require("ilib-es6/lib/PhoneNumber"));

var _PhoneFmt = _interopRequireDefault(require("ilib-es6/lib/PhoneFmt"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PhoneFmt =
/*#__PURE__*/
function (_React$Component) {
  _inherits(PhoneFmt, _React$Component);

  function PhoneFmt(props) {
    var _this;

    _classCallCheck(this, PhoneFmt);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PhoneFmt).call(this, props));
    var locale = props.locale,
        style = props.style;
    _this.state = {
      formatter: new _PhoneFmt["default"](props),
      locale: locale
    };
    return _this;
  }

  _createClass(PhoneFmt, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _this2 = this;

      if (prevProps.locale !== this.props.locale || prevProps.mcc !== this.props.mcc || prevProps.style !== this.props.style) {
        _PhoneFmt["default"].create(this.props).then(function (fmt) {
          _this2.setState({
            formatter: fmt
          });
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _ref = this.props || {},
          className = _ref.className,
          number = _ref.number;

      var _ref2 = this.props || {},
          id = _ref2.id,
          wrapper = _ref2.wrapper,
          phone = _ref2.phone;

      phone = typeof number === "string" ? new _PhoneNumber["default"](number, {
        locale: this.state.locale || this.state.formatter.locale
      }) : number;
      var ret = this.state.formatter.format(phone);

      if (wrapper) {
        id = id || String(number);
        var attrs = {
          key: id,
          id: id
        };
        className && (attrs["className"] = className);
        return typeof wrapper === "string" ? React.createElement(wrapper, attrs, ret) : React.cloneElement(wrapper, attrs, ret);
      } else {
        return ret;
      }
    }
  }]);

  return PhoneFmt;
}(React.Component);

_defineProperty(PhoneFmt, "propTypes", {
  locale: _propTypes["default"].string,
  style: _propTypes["default"].string,
  mcc: _propTypes["default"].string,
  number: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]).isRequired,
  id: _propTypes["default"].string,
  wrapper: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object])
});

var _default = PhoneFmt;
exports["default"] = _default;
//# sourceMappingURL=PhoneFmt.js.map
