"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _hash = _interopRequireDefault(require("../utils/hash"));

var _Composition = _interopRequireDefault(require("../utils/Composition"));

var _LocaleContext = require("./LocaleContext");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * Replace the text inside of this component with a translation. This
 * component is built on top of react-intl, so it works along with the
 * regular react-intl components and objects you are used to, and it gets
 * its translations from react intl as well. The Translate component can
 * be used wherever it is valid to put JSX text. In regular Javascript
 * code, you should continue to use the intl.formatMessage() call and
 * extract your strings into a message.js file.
 */
var Translate =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Translate, _React$Component);

  function Translate(props) {
    var _this;

    _classCallCheck(this, Translate);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Translate).call(this, props));
    var id = _this.props.id;
    var _this$props = _this.props,
        count = _this$props.count,
        children = _this$props.children;
    var sourceElements = children;

    if (!children) {
      throw new Error("Translate component with no child elements. Can't translate 'nothing!'");
    }

    if (sourceElements) {
      var composition = new _Composition["default"](sourceElements);
      var source = ''; // eslint-disable-next-line no-restricted-globals

      if (!isNaN(Number(count))) {
        if (children) {
          source = _this.composePluralString(children);
        } else {
          console.warn("Cannot use count prop on a Translate component that has no children.");
        }
      } else {
        source = composition.compose();
      }

      id = id || (0, _hash["default"])(source);
      _this.state = {
        id: id,
        source: source,
        composition: composition
      };
    }

    return _this;
  }
  /**
   * Search for any Plural elements in the children, and
   * then construct the English source string in the correct
   * format for ilib to use for pluralization
   * @param {React.Element} children the children of this node
   * @return {string} the composed plural string
   */


  _createClass(Translate, [{
    key: "composePluralString",
    value: function composePluralString(children) {
      var categories = {};
      React.Children.forEach(children, function (child) {
        if (_typeof(child) === 'object' && React.isValidElement(child) && child.type.name === 'Plural') {
          var childComposition = new _Composition["default"](child.props.children);
          categories[child.props.category] = childComposition.compose();
        }
      });

      if (!categories.one || !categories.other) {
        throw new Error('Cannot use count prop on a Translate component without giving both a "one" and "other" Plural component in the children.');
      } // add these to the string in a particular order so that
      // we always end up with the same string regardless of
      // the order that the Plural elements were specified in
      // the source code


      var categoriesString = ['zero', 'one', 'two', 'few', 'many', 'other', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19'].filter(function (category) {
        return !!categories[category];
      }).map(function (category) {
        return "".concat(category === "other" ? '' : category, "#").concat(categories[category]);
      }).join('|');
      return categoriesString;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          count = _this$props2.count,
          tagName = _this$props2.tagName,
          description = _this$props2.description,
          rb = _this$props2.rb;
      var _this$state = this.state,
          composition = _this$state.composition,
          id = _this$state.id,
          source = _this$state.source;
      var values = {};

      if (typeof count === 'number') {
        // make sure intl.formatMessage switches properly on the count
        values.count = count;
      }

      var translation = rb.getString(source, id);
      translation = typeof count === 'number' ? translation.formatChoice(count, values) : translation.toString(); // always wrap the translated string in a tag to contain everything
      // and to give us a spot to record the id

      return React.createElement(tagName || 'span', {
        key: id,
        'x-resource-id': id
      }, composition.decompose(translation));
    }
  }]);

  return Translate;
}(React.Component);
/* make sure eslint is happy with accessing the children property above */


Translate.propTypes = {
  id: _propTypes["default"].string,
  description: _propTypes["default"].string,
  tagName: _propTypes["default"].string,
  count: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])
};

var _default = (0, _LocaleContext.withLocale)(Translate);

exports["default"] = _default;
//# sourceMappingURL=Translate.js.map
