"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _MeasurementFactory = _interopRequireDefault(require("ilib-es6/lib/MeasurementFactory"));

var _UnitFmt = _interopRequireDefault(require("ilib-es6/lib/UnitFmt"));

var _hash = _interopRequireDefault(require("../utils/hash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var UnitFmt =
/*#__PURE__*/
function (_React$Component) {
  _inherits(UnitFmt, _React$Component);

  function UnitFmt(props) {
    var _this;

    _classCallCheck(this, UnitFmt);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(UnitFmt).call(this, props));
    _this.state = {
      formatter: new _UnitFmt["default"](props)
    };
    return _this;
  }

  _createClass(UnitFmt, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var diff = ["locale", "autoScale", "autoConvert", "usage", "style", "length", "maxFractionDigits", "minFractionDigits", "significantDigits", "roundingMode"].some(function (prop) {
        return prevProps[prop] !== this.props[prop];
      });

      if (diff) {
        new _UnitFmt["default"]({
          locale: this.props.locale,
          autoScale: this.props.autoScale,
          autoConvert: this.props.autoConvert,
          usage: this.props.usage,
          style: this.props.style,
          length: this.props.length,
          maxFractionDigits: this.props.maxFractionDigits,
          minFractionDigits: this.props.minFractionDigits,
          significantDigits: this.props.significantDigits,
          roundingMode: this.props.roundingMode,
          sync: false,
          onLoad: function (fmt) {
            this.setState({
              formatter: fmt
            });
          }.bind(this)
        });
      }
    }
  }, {
    key: "measureHash",
    value: function measureHash(m) {
      return (0, _hash["default"])([m.getMeasure(), m.getUnit(), m.getAmount().toString()].join('-'));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          measure = _this$props.measure,
          id = _this$props.id,
          wrapper = _this$props.wrapper,
          className = _this$props.className;
      var ret = this.state.formatter.format(measure);

      if (wrapper) {
        id = id || this.measureHash(measure);
        var attrs = {
          key: id,
          id: id
        };
        className && (attrs["className"] = className);
        return React.cloneElement(wrapper, attrs, ret);
      } else {
        return ret;
      }
    }
  }]);

  return UnitFmt;
}(React.Component);

_defineProperty(UnitFmt, "propTypes", {
  locale: _propTypes["default"].string,
  autoScale: _propTypes["default"].bool,
  autoConvert: _propTypes["default"].bool,
  usage: _propTypes["default"].string,
  style: _propTypes["default"].string,
  length: _propTypes["default"].string,
  id: _propTypes["default"].string,
  wrapper: _propTypes["default"]["object"],
  maxFractionDigits: _propTypes["default"].number,
  minFractionDigits: _propTypes["default"].number,
  significantDigits: _propTypes["default"].number,
  roundingMode: _propTypes["default"].string,
  measure: _propTypes["default"]["object"].isRequired,
  children: _propTypes["default"].any
});

var _default = UnitFmt;
exports["default"] = _default;
//# sourceMappingURL=UnitFmt.js.map
